package domowe.r4.odmiana_slow;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class BazaOdmian_v1 {
	// dla formy podstawowej zawiera zbiór odmian
	private Map<String, Set<String>> odmiany = new HashMap<>();
	
	void wczytajDaneZPliku(String sciezka) {
		try(Scanner scanner = new Scanner(new File(sciezka))) {
			while(scanner.hasNextLine()) {
				String linia = scanner.nextLine();
				String[] t = linia.split("\t");
				Set<String> zbiorOdmian = odmiany.get(t[1]);
				if(zbiorOdmian == null) {
					zbiorOdmian = new HashSet<>();
					odmiany.put(t[1], zbiorOdmian);
				}
				zbiorOdmian.add(t[0]);
			}
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	Set<String> znajdzFormyPodstawowe(String slowoOdmienione) {
		// W tej wersji przeglądamy całą bazę wiedzy sprawdzając gdzie wsytępuje taie słowo odmienione
		HashSet<String> wyniki = new HashSet<>();
		for (Map.Entry<String, Set<String>> entry : odmiany.entrySet()) {
			// jeśli zbiór odmian zawiera slowoOdmienione, to klucz (czyli forma bazowa) powinien być dodany do wyników tej metody
			if(entry.getValue().contains(slowoOdmienione)) {
				wyniki.add(entry.getKey());
			}
		}
		
		return wyniki;
	}

	Set<String> znajdzOdmiany(String slowo) {
		return odmiany.get(slowo);
	}

}


