package domowe.r4.odmiana_slow;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class BazaOdmian_v2 {
	private static final String DOMYSLNY_PLIK = "PoliMorf-0.6.7.tab";
	
	// dla formy podstawowej zawiera zbiór odmian
	private final Map<String, Set<String>> odmiany = new HashMap<>();

	// dla formy odmienionej zawiera zbiór form podstawowych
	private final Map<String, Set<String>> podstawowe = new HashMap<>();
	
	// tylko po to, aby konstruktor nie był publiczny:
	private BazaOdmian_v2() {
		
	}
	
	// oficjalnym, publicznym sposobem tworzenia obiektów jest ta metoda statyczna:
	public static BazaOdmian_v2 zPliku(String sciezka) {
		BazaOdmian_v2 baza = new BazaOdmian_v2();
		baza.wczytajDaneZPliku(sciezka);
		return baza;
	}
	
	public static BazaOdmian_v2 zDomyslnegoPliku() {
		return BazaOdmian_v2.zPliku(DOMYSLNY_PLIK);
	}
	
	// to jest metoda pomocnicza, więc oznaczam jako prywatną
	private void wczytajDaneZPliku(String sciezka) {
		try(Scanner scanner = new Scanner(new File(sciezka))) {
			while(scanner.hasNextLine()) {
				String linia = scanner.nextLine();
				String[] t = linia.split("\t");
				Set<String> zbiorOdmian = odmiany.get(t[1]);
				if(zbiorOdmian == null) {
					zbiorOdmian = new HashSet<>();
					odmiany.put(t[1], zbiorOdmian);
				}
				zbiorOdmian.add(t[0]);

				Set<String> zbiorPodstawowych = podstawowe.get(t[0]);
				if(zbiorPodstawowych == null) {
					zbiorPodstawowych = new HashSet<>();
					podstawowe.put(t[0], zbiorPodstawowych);
				}
				zbiorPodstawowych.add(t[1]);
			}
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	public Set<String> znajdzFormyPodstawowe(String slowoOdmienione) {
		return podstawowe.get(slowoOdmienione);
	}

	public Set<String> znajdzOdmiany(String slowo) {
		return odmiany.get(slowo);
	}

}


