package domowe.r4.odmiana_slow;

import java.io.File;
import java.io.FileNotFoundException;
import java.text.Collator;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeMap;

public class PoliczKazdeSlowo6 {

	public static void main(String[] args) {
		System.out.println("Buduję bazę odmian...");
		BazaOdmian_MaleLitery bazaOdmian = BazaOdmian_MaleLitery.zDomyslnegoPliku();
		
		try (Scanner scanner = new Scanner(new File("pan-tadeusz.txt"))) {
			scanner.useDelimiter("[^\\p{L}\\d]+");
			
			System.out.println("Buduję mapę...");
			Map<String, Integer> mapa = new TreeMap<>(Collator.getInstance());
			while(scanner.hasNext()) {
				String slowo = scanner.next().toLowerCase().intern();
				Set<String> podstawowe = bazaOdmian.znajdzFormyPodstawowe(slowo);
				if(!podstawowe.isEmpty()) {
					slowo = podstawowe.iterator().next(); // biorę pierwszą formę podstawową
				}
				int ileBylo = mapa.getOrDefault(slowo, 0);
				mapa.put(slowo, ileBylo+1);
			}
			
			System.out.println("Unikalnych słów: " + mapa.size());
			
			System.out.println("Sortuję dane...");
			List<Map.Entry<String, Integer>> lista = new ArrayList<>(mapa.entrySet());
			// W Java 8 do Map.Entry dodano gotowy komparator, którego możemy użyć
			lista.sort(Map.Entry.comparingByValue());
			
			for (Map.Entry<String, Integer> entry : lista) {
				System.out.printf("%-15s → %4d razy\n", entry.getKey(), entry.getValue());
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

}
