package domowe.r4.odmiana_slow;

import java.util.Scanner;
import java.util.Set;

public class TestOdmian {

	public static void main(String[] args) {
		long p, k;
		System.out.println("Wczytuję bazę odmian..");
		p = System.nanoTime();
		
		BazaOdmian baza = BazaOdmian.zDomyslnegoPliku();
		k = System.nanoTime();
		System.out.printf("Wczytywanie trwało %,d us\n", k-p);
		
		Runtime runtime = Runtime.getRuntime();
		System.out.printf("Zajęta pamięć: %,d\n", runtime.totalMemory() - runtime.freeMemory());
		
		Scanner scanner = new Scanner(System.in);
		while(true) {
			System.out.print("Podaj słowo: ");
			String slowo = scanner.nextLine();
			if(slowo.isEmpty())
				break;
			
			p = System.nanoTime();
			Set<String> odmiany = baza.znajdzOdmiany(slowo);
			k = System.nanoTime();
			System.out.printf("(czas %,d) Słowo %s posiada nast. odmiany: %s\n", k-p, slowo, odmiany);

			p = System.nanoTime();
			Set<String> podstawowe = baza.znajdzFormyPodstawowe(slowo);
			k = System.nanoTime();
			System.out.printf("(czas %,d) Słowo %s jest odmianą takich słów: %s\n", k-p, slowo, podstawowe);
			System.out.println();
			
		}

	}

}
